VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CallDistribution"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Const DefaultTransferTarget As String = "20"
Dim TransferTarget As String

Dim CustomerID As String

Dim CallController As CallController

Private Enum CDStates
    csStart = 0
    csAskCustomerID = 1
    csTransfer = 4
    csExecuteTransfer = 5
    csError = 99
End Enum

Dim CDState As CDStates
Dim CurrentDigit As String

Dim CON As ADODB.Connection

Implements ITVCallHandler

Private Sub Class_Terminate()
    Set CallController = Nothing
End Sub

Private Sub ITVCallHandler_Init(objCallController As TERAVoiceLib.CallController)

    Set CallController = objCallController
    
    'Init Connection
    
    On Error Resume Next
    
    Set CON = New ADODB.Connection
    
    CON.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & App.Path & "\CallDistribution.mdb" & ";OLE DB Services=-1;"
    CON.Open
    
    If Err Then
        Set CON = Nothing
        'Access to the database failed
    End If
    
End Sub

Private Sub ITVCallHandler_DigitReceived(Digit As String)


    'In this sample we will dispatch all processing through the
    'ITVCallHandler_TimePulse function. This function always gets
    'called immediately after ITVCallHandler_DigitReceived, so
    'we simply store the current received digit only
    
    CurrentDigit = Digit
    
        
End Sub

Private Sub ITVCallHandler_FileSaved(FileName As String, Length As Long)
    'This procedure is not needed in this sample
    'All procedures of ITVCallHandler must be implemented though!
End Sub

Private Sub ITVCallHandler_PlayDone()

End Sub

Private Sub ITVCallHandler_TimePulse()
Dim RS As ADODB.Recordset
Dim Result As String
Dim i As Long
Dim Digit As String

    'Ensure that we process each digit only once by clearing
    'the digit saved in the ITVCallHandler_DigitReceived function
    Digit = CurrentDigit
    CurrentDigit = ""
    
    Select Case CDState
    Case csStart
        'If our connection to the database has failed then transfer
        'to default extension
        If CON Is Nothing Then
            TransferTarget = DefaultTransferTarget
            CDState = csTransfer
            Exit Sub
        End If
        'First we try to determine the assistant to transfer this
        'call to by checking the CallerID
        If CallController.CallerID <> "" Then
            Set RS = New ADODB.Recordset
            'for simplicity of this sample we ignore things like area-codes and country-codes
            RS.Open "SELECT * FROM Customers_Assistants_View WHERE Phone='" & CallController.CallerID & "'", CON, adOpenKeyset
            If Not RS.EOF Then
                RS.MoveLast
                RS.MoveFirst
                'This is needed to get a correct result for RecordCount
            End If
            If RS.RecordCount = 1 Then
                TransferTarget = RS("PhoneExtension")
                CDState = csTransfer
            Else
                'if there are zero or more than one entries we need to ask for CustomerID
                CDState = csAskCustomerID
            End If
        Else
            CDState = csAskCustomerID
        End If
    Case csAskCustomerID
        Select Case Digit
        Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"
            CustomerID = CustomerID & Digit
            CallController.StopPlayRecord
            Exit Sub
        Case "#"
            If CustomerID = "" Then
                TransferTarget = DefaultTransferTarget
            Else
                Set RS = CON.Execute("SELECT * FROM Customers_Assistants_View WHERE CustomerID=" & CustomerID)
                If Not RS.EOF Then
                    TransferTarget = RS("PhoneExtension")
                Else
                    TransferTarget = DefaultTransferTarget
                End If
                Set RS = Nothing
            End If
            CDState = csTransfer
        Case Else
            If (Not CallController.IsPlaying) And (TransferTarget = "") Then
                If Not CallController.PlayAudioFile(App.Path & "\AskCustomerID.wav") Then
                    CallController.WriteLogFile 20, "Unable to play audio file", True
                    CallController.HangUp
                End If
            End If
        End Select
    Case csTransfer
        If Not CallController.PlayAudioFile(App.Path & "\YouWillBeTransferred.wav") Then
            CallController.WriteLogFile 22, "Unable to play audio file", True
            CallController.HangUp
            Exit Sub
        End If
        CDState = csExecuteTransfer
    Case csExecuteTransfer
        If Not CallController.IsPlaying Then 'Wait until message has finished playing
            If Not CallController.TransferCall(TransferTarget, 0) Then
                If Not CallController.PlayAudioFile(App.Path & "\UnableToTransfer.wav") Then
                    CallController.WriteLogFile 24, "Unable to play audio file", True
                    CallController.HangUp
                End If
                CallController.HangUp
                CDState = csError
                Exit Sub
            End If
        End If
    End Select
        

    
End Sub





Private Sub ITVCallHandler_UnInit()

    'Important: Do not forget to destroy this object!!!
    Set CallController = Nothing
    
    'Also do not forget to destroy object references,
    'otherwise this object might never get unloaded
    
    Set CON = Nothing
    
End Sub


